/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksMetastoresConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/metastores#id DataDatabricksMetastores#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/metastores#ids DataDatabricksMetastores#ids}
    */
    readonly ids?: {
        [key: string]: string;
    };
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/metastores databricks_metastores}
*/
export declare class DataDatabricksMetastores extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_metastores";
    /**
    * Generates CDKTF code for importing a DataDatabricksMetastores resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksMetastores to import
    * @param importFromId The id of the existing DataDatabricksMetastores that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/metastores#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksMetastores to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/metastores databricks_metastores} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksMetastoresConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksMetastoresConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ids?;
    get ids(): {
        [key: string]: string;
    };
    set ids(value: {
        [key: string]: string;
    });
    resetIds(): void;
    get idsInput(): {
        [key: string]: string;
    } | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
