/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksQualityMonitorsV2Config extends cdktf.TerraformMetaArguments {
}
export interface DataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfig {
}
export declare function dataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfigToTerraform(struct?: DataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfig): any;
export declare function dataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfigToHclTerraform(struct?: DataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfig): any;
export declare class DataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfig | undefined;
    set internalValue(value: DataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfig | undefined);
    get lastRunId(): string;
    get latestRunStatus(): string;
}
export interface DataDatabricksQualityMonitorsV2QualityMonitors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/quality_monitors_v2#object_id DataDatabricksQualityMonitorsV2#object_id}
    */
    readonly objectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/quality_monitors_v2#object_type DataDatabricksQualityMonitorsV2#object_type}
    */
    readonly objectType: string;
}
export declare function dataDatabricksQualityMonitorsV2QualityMonitorsToTerraform(struct?: DataDatabricksQualityMonitorsV2QualityMonitors): any;
export declare function dataDatabricksQualityMonitorsV2QualityMonitorsToHclTerraform(struct?: DataDatabricksQualityMonitorsV2QualityMonitors): any;
export declare class DataDatabricksQualityMonitorsV2QualityMonitorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksQualityMonitorsV2QualityMonitors | undefined;
    set internalValue(value: DataDatabricksQualityMonitorsV2QualityMonitors | undefined);
    private _anomalyDetectionConfig;
    get anomalyDetectionConfig(): DataDatabricksQualityMonitorsV2QualityMonitorsAnomalyDetectionConfigOutputReference;
    private _objectId?;
    get objectId(): string;
    set objectId(value: string);
    get objectIdInput(): string | undefined;
    private _objectType?;
    get objectType(): string;
    set objectType(value: string);
    get objectTypeInput(): string | undefined;
}
export declare class DataDatabricksQualityMonitorsV2QualityMonitorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksQualityMonitorsV2QualityMonitors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksQualityMonitorsV2QualityMonitorsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/quality_monitors_v2 databricks_quality_monitors_v2}
*/
export declare class DataDatabricksQualityMonitorsV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_quality_monitors_v2";
    /**
    * Generates CDKTF code for importing a DataDatabricksQualityMonitorsV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksQualityMonitorsV2 to import
    * @param importFromId The id of the existing DataDatabricksQualityMonitorsV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/quality_monitors_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksQualityMonitorsV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/quality_monitors_v2 databricks_quality_monitors_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksQualityMonitorsV2Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksQualityMonitorsV2Config);
    private _qualityMonitors;
    get qualityMonitors(): DataDatabricksQualityMonitorsV2QualityMonitorsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
