/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksRecipientFederationPoliciesConfig extends cdktf.TerraformMetaArguments {
}
export interface DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#audiences DataDatabricksRecipientFederationPolicies#audiences}
    */
    readonly audiences?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#issuer DataDatabricksRecipientFederationPolicies#issuer}
    */
    readonly issuer: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#subject DataDatabricksRecipientFederationPolicies#subject}
    */
    readonly subject: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#subject_claim DataDatabricksRecipientFederationPolicies#subject_claim}
    */
    readonly subjectClaim: string;
}
export declare function dataDatabricksRecipientFederationPoliciesPoliciesOidcPolicyToTerraform(struct?: DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy | cdktf.IResolvable): any;
export declare function dataDatabricksRecipientFederationPoliciesPoliciesOidcPolicyToHclTerraform(struct?: DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy | cdktf.IResolvable): any;
export declare class DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy | cdktf.IResolvable | undefined);
    private _audiences?;
    get audiences(): string[];
    set audiences(value: string[]);
    resetAudiences(): void;
    get audiencesInput(): string[] | undefined;
    private _issuer?;
    get issuer(): string;
    set issuer(value: string);
    get issuerInput(): string | undefined;
    private _subject?;
    get subject(): string;
    set subject(value: string);
    get subjectInput(): string | undefined;
    private _subjectClaim?;
    get subjectClaim(): string;
    set subjectClaim(value: string);
    get subjectClaimInput(): string | undefined;
}
export interface DataDatabricksRecipientFederationPoliciesPolicies {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#comment DataDatabricksRecipientFederationPolicies#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#name DataDatabricksRecipientFederationPolicies#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#oidc_policy DataDatabricksRecipientFederationPolicies#oidc_policy}
    */
    readonly oidcPolicy?: DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy;
}
export declare function dataDatabricksRecipientFederationPoliciesPoliciesToTerraform(struct?: DataDatabricksRecipientFederationPoliciesPolicies): any;
export declare function dataDatabricksRecipientFederationPoliciesPoliciesToHclTerraform(struct?: DataDatabricksRecipientFederationPoliciesPolicies): any;
export declare class DataDatabricksRecipientFederationPoliciesPoliciesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksRecipientFederationPoliciesPolicies | undefined;
    set internalValue(value: DataDatabricksRecipientFederationPoliciesPolicies | undefined);
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    get createTime(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _oidcPolicy;
    get oidcPolicy(): DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicyOutputReference;
    putOidcPolicy(value: DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy): void;
    resetOidcPolicy(): void;
    get oidcPolicyInput(): cdktf.IResolvable | DataDatabricksRecipientFederationPoliciesPoliciesOidcPolicy | undefined;
    get updateTime(): string;
}
export declare class DataDatabricksRecipientFederationPoliciesPoliciesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksRecipientFederationPoliciesPolicies[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksRecipientFederationPoliciesPoliciesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies databricks_recipient_federation_policies}
*/
export declare class DataDatabricksRecipientFederationPolicies extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_recipient_federation_policies";
    /**
    * Generates CDKTF code for importing a DataDatabricksRecipientFederationPolicies resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksRecipientFederationPolicies to import
    * @param importFromId The id of the existing DataDatabricksRecipientFederationPolicies that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksRecipientFederationPolicies to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.83.0/docs/data-sources/recipient_federation_policies databricks_recipient_federation_policies} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksRecipientFederationPoliciesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksRecipientFederationPoliciesConfig);
    private _policies;
    get policies(): DataDatabricksRecipientFederationPoliciesPoliciesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
